pro gsmooth, array, FWHM=fwhm
;
;	smooths array by a gaussian with fwhm
;
;	DPC		20150908
;
asize = SIZE(array)
nx = asize[1]
ny = asize[2]
;
new_array = array * 0.0
sigma_2 = (fwhm / 2.354)^2
;
;	compute gaussian kernel
;
g = fltarr(11,11)
jy = findgen(11)
;
for jx = 0, 10 do begin
	roff_2 = float((jx - 5)^2) + float((jy - 5)^2)
	g[jx,0:10] = exp(-0.5 * roff_2 / sigma_2)
endfor
;
;	normalize gaussian by area integral
;
gsum = TOTAL(g,/double)
g /= gsum
;
;	convolve with this kernel
;
new_array = CONVOL(array, g, /EDGE_WRAP, /NORMALIZE)
;
array = new_array
;
end