pro	Modify_Textbox, Event, str
;
;	handles modifying the contents of a textbox and saving the results in the structure
;	based on the str descriptor
;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_Struct
	s_ptr = PTR_Struct.PTR_summary
	w_ptr = PTR_Struct.PTR_wid
	;
	case str of
		"Nstars": 	begin & wid = (*w_ptr).Nstars_Textbox_wid 	& ibox = 0 & vtype = 'I' & end
		"Beta": 	begin & wid = (*w_ptr).Beta_Textbox_wid	  	& ibox = 1 &vtype = 'F' & end
		"M0": 		begin & wid = (*w_ptr).M0_Textbox_wid		& ibox = 2 &vtype = 'F' & end
		"M1": 		begin & wid = (*w_ptr).M1_Textbox_wid		& ibox = 3 &vtype = 'F' & end
		"Mag_Offset": begin & wid = (*w_ptr).Mag_Offset_Textbox_wid & ibox = 4 &vtype = 'F' & end
		"P0": 		begin & wid = (*w_ptr).P0_Textbox_wid		& ibox = 5 &vtype = 'F' & end
		"P1": 		begin & wid = (*w_ptr).P1_Textbox_wid		& ibox = 6 &vtype = 'F' & end
		"EPA0": 	begin & wid = (*w_ptr).EPA0_Textbox_wid		& ibox = 7 &vtype = 'F' & end
		"EPA1": 	begin & wid = (*w_ptr).EPA1_Textbox_wid		& ibox = 8 &vtype = 'F' & end
		"Run Number": begin & wid = (*w_ptr).Run_Number_Textbox_wid & ibox = 9 &vtype = 'I' & end
	endcase
	;
;	print_text, Event, 'in Modify_Term, ibox, wid, Event.type = '+STRING(ibox,wid,Event.type,$
;					format='(I2,1x,I3,1x,I3)')
	;
	;	first, fetch current pointer into text box buffer
	;
	nch = (*w_ptr).Term_textbox_nch[ibox]
	;
	new_name = 0
	;
	if(Event.type eq 0) then begin
		;
		;	if character not CR, put it into buffer
		;
		ch = Event.ch
		if(ch ne 10B) then begin
			WIDGET_CONTROL, wid, GET_VALUE=existing_text
			(*w_ptr).Term_textbox_nch[ibox] = STRLEN(existing_text)
			for il = 0, STRLEN(existing_text[0])-1 do (*w_ptr).Term_textbox_buffer[ibox,il] = STRMID(existing_text, il, 1)
			WIDGET_CONTROL, wid, SET_TEXT_SELECT=[Event.offset,0]
			;
		endif else begin
			;
			;	was a character return - load the buffer into a single string
			;
			name = ''
			for ich = 0, (*w_ptr).Term_textbox_nch[ibox]-1 do begin
				name = name + (*w_ptr).Term_textbox_buffer[ibox,ich]
			endfor
			name = STRTRIM(name,2)
			;
			;	new name available - put it into current buffer and issue a relist command
			;
			new_name = 1
			;
		endelse
		;
		;print_text, Event, "Insert Character Event - Character = "+STRING(format='(a)',Event.ch)
	endif else begin
		if(Event.type eq 1) then begin
			WIDGET_CONTROL, wid, GET_VALUE=existing_text
			name = STRTRIM(Event.str,2)
			length = STRLEN(name)
			if(length gt 1) then begin
				this_name = strarr(length)
				for il=0, length-1 do begin
					this_name[il] = STRMID(name,il,1)
				endfor
			endif else begin
				if(length eq 0) then goto, MT_end
				;
				this_name = strarr(1)
				this_name[0] = name
			endelse
			new_name = 1
			;
		endif else begin
			if(Event.type eq 2) then begin							; delete
				WIDGET_CONTROL, wid, GET_VALUE=existing_text
				;
				;	if length = 0 just skip
				;
				if(Event.length eq 0) then goto, MT_end
				;

			endif else begin
				if(Event.type eq 3) then begin
;					print_text, Event, 'Text selected'
					goto, MT_end
				endif else begin
					print_text, Event, 'Event type = '+STRING(Event.type,format='(I)')
					;
					a = 0
					;
				endelse
			endelse
		endelse
		(*w_ptr).Term_textbox_nch[ibox] = STRLEN(existing_text)
		for il = 0, STRLEN(existing_text[0])-1 do (*w_ptr).Term_textbox_buffer[ibox,il] = STRMID(existing_text, il, 1)
		WIDGET_CONTROL, wid, SET_TEXT_SELECT=[Event.offset,0]
	endelse
	;
	if(new_name eq 1) then begin
		;
		;	replace old value with new, but only accept good floating point value
		;
		CATCH, ibad
		;
		if(ibad ne 0) then begin
			print_text, Event, "Bad input, try again"
			;
			;	clear buffer to old values
			;
			(*w_ptr).Term_textbox_nch[ibox] = 0
			(*w_ptr).Term_textbox_buffer[ibox,*] = ''
			;
			;	and reshow
			;
			Show_Textboxes, Event
			;
			CATCH, /CANCEL
			;
			goto, MT_end
		endif
		;
		reads, name, format='('+STRTRIM(vtype,2)+')', value
		;
		print_text, Event, "Replacing "+str+" value with "+STRING(format='('+STRTRIM(vtype,2)+')',value)
		;
		;value
		;
		;	store value in correct buffer
		;
		case str of
			"Nstars": 	(*w_ptr).Nstars = value
			"Beta": 	(*w_ptr).Beta = value
			"M0": 		(*w_ptr).M0 = value
			"M1": 		(*w_ptr).M1 = value
			"Mag_Offset": (*w_ptr).Mag_Offset = value
			"P0": 		(*w_ptr).P0 = value
			"P1": 		(*w_ptr).P1 = value
			"EPA0": 	(*w_ptr).EPA0 = value
			"EPA1": 	(*w_ptr).EPA1 = value
			"Run Number": (*w_ptr).Run_Number = value
		endcase
		;
		Show_Textboxes, Event
		;
		;	clear buffer
		;
		(*w_ptr).Term_textbox_nch[ibox] = 0
		(*w_ptr).Term_textbox_buffer[ibox,*] = ''
		;
		CATCH, /CANCEL
	endif
	;
	MT_end:
	;
end